package gregapi.data;

import static gregapi.data.CS.*;
import gregapi.code.IItemContainer;
import gregapi.oredict.OreDictItemData;
import gregapi.recipes.GT_ModHandler;
import gregapi.util.OM;
import gregapi.util.UT;
import net.minecraft.block.Block;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraftforge.fluids.Fluid;

/**
 * @author Gregorius Techneticies
 * 
 * Class containing all non-OreDict Items of GregTech.
 */
public enum IL implements IItemContainer {
	Display_Fluid,
	Circuit_Selector, Circuit_Integrated, // <-- this is the Circuit that has the adjustable Numbers on it
	TE_Slag, TE_Slag_Rich, TE_Cinnabar,
	TE_Phyto_Gro, TE_Phyto_Gro_Rich,
	TE_Rockwool,
	FR_Planks_Fireproof, FR_Planks,
	FR_Slabs_Fireproof, FR_Slabs,
	FR_Logs_Fireproof, FR_Logs,
	FR_Ice_Shard,
	FR_Iodine_Capsule, FR_Dissipation_Capsule,
	FR_Propolis, FR_Propolis_Silky, FR_Propolis_Sticky, FR_Propolis_Pulsating,
	FR_Pulsating_Dust, FR_Pulsating_Mesh,
	FR_Silk, FR_Silk_Woven,
	FR_Candle,
	FR_Mulch, FR_Fertilizer, FR_Compost,
	FR_HoneyPot, FR_Ambrosia, FR_TinCapsule, FR_WaxCapsule, FR_RefractoryCapsule,
	FR_Stick,
	FR_Casing_Impregnated, FR_Casing_Sturdy, FR_Casing_Hardened,
	FR_Bee_Drone, FR_Bee_Princess, FR_Bee_Queen, FR_Tree_Sapling, FR_Butterfly, FR_Larvae, FR_Serum, FR_Caterpillar, FR_PollenFertile,
	FR_Royal_Jelly,
	FR_Phosphor,
	FR_Comb_Honey, FR_Comb_Cocoa, FR_Comb_Simmering, FR_Comb_Stringy, FR_Comb_Frozen, FR_Comb_Dripping, FR_Comb_Silky, FR_Comb_Parched, FR_Comb_Mysterious, FR_Comb_Irradiated, FR_Comb_Powdery, FR_Comb_Reddened, FR_Comb_Darkened, FR_Comb_Omega, FR_Comb_Wheaten, FR_Comb_Mossy, FR_Comb_Mellow,
	FR_Pollen_Cluster, FR_Pollen_Cluster_Crystalline,
	BoP_Dye_Black, BoP_Dye_Blue, BoP_Dye_Brown, BoP_Dye_White, BoP_Dye_Green,
	BoP_Flesh, BoP_Celestial, BoP_Comb, BoP_Ashes, BoP_Mudbrick, BoP_GhastlySoul, BoP_PixieDust, BoP_Ichor, BoP_Pinecone, BoP_Berry, BoP_ShroomPowder, BoP_WildCarrots, BoP_Peach, BoP_Persimmon, BoP_HoneyComb, BoP_Ambrosia, BoP_Turnip, BoP_Pear, BoP_Jar_Empty, BoP_Jar_Honey, BoP_Jar_Poison, BoP_Jar_Pixie,
	EBXL_Dye_Black, EBXL_Dye_Blue, EBXL_Dye_Brown, EBXL_Dye_White,
	EBXL_Cactus_Paste,
	MFR_Fertilizer,
	RoC_Propolis_Slippery,
	RoC_Comb_Slippery,
	TF_LiveRoot, TF_Mushgloom,
	TF_Vial_FieryBlood, TF_Vial_FieryTears,
	TF_Hydrachop_Raw, TF_Meef_Raw, TF_Meef_Cooked, TF_Venison_Raw, TF_Venison_Cooked,
	RC_ShuntingWire, RC_ShuntingWireFrame,
	RC_Rail_Reinforced, RC_Rail_Electric, RC_Rail_Standard, RC_Rail_Wooden, RC_Rail_Adv, RC_Rail_HS,
	RC_Tie_Wood, RC_Tie_Stone, RC_Bed_Wood, RC_Bed_Stone,
	RC_Rebar,
	RC_Post_Metal,
	RC_Crowbar_Iron, RC_Crowbar_Steel, RC_Crowbar_Thaumium, RC_Crowbar_Voidmetal,
	IC2_Fertilizer, IC2_Grin_Powder, IC2_Spray_WeedEx,
	IC2_Scaffold, IC2_Scaffold_Iron,
	IC2_Scrap, IC2_Scrapbox,
	IC2_Mixed_Metal_Ingot, IC2_Advanced_Alloy,
	IC2_Resin,
	IC2_Plantball, IC2_Biochaff,
	IC2_Crop_Seeds,
	IC2_Coal_Ball, IC2_Compressed_Coal_Ball, IC2_Compressed_Coal_Chunk,
	IC2_Carbon_Fiber, IC2_Carbon_Mesh, IC2_Carbon_Plate,
	IC2_Fuel_Rod_Empty,
	IC2_Food_Can_Empty, IC2_Food_Can_Filled, IC2_Food_Can_Spoiled,
	IC2_ShaftIron, IC2_ShaftSteel,
	IC2_Industrial_Diamond,
	IC2_Energium_Dust,
	IC2_ForgeHammer, IC2_WireCutter,
	IC2_SuBattery, IC2_ReBattery, IC2_AdvBattery, IC2_EnergyCrystal, IC2_LapotronCrystal,
	NC_SensorCard, NC_SensorKit,
	Arrow_Head_Glass_Emtpy, Arrow_Head_Glass_Poison, Arrow_Head_Glass_Poison_Long, Arrow_Head_Glass_Poison_Strong, Arrow_Head_Glass_Slowness, Arrow_Head_Glass_Slowness_Long, Arrow_Head_Glass_Weakness, Arrow_Head_Glass_Weakness_Long, Arrow_Head_Glass_Holy_Water,
	Arrow_Wooden_Glass_Emtpy, Arrow_Wooden_Glass_Poison, Arrow_Wooden_Glass_Poison_Long, Arrow_Wooden_Glass_Poison_Strong, Arrow_Wooden_Glass_Slowness, Arrow_Wooden_Glass_Slowness_Long, Arrow_Wooden_Glass_Weakness, Arrow_Wooden_Glass_Weakness_Long, Arrow_Wooden_Glass_Holy_Water,
	Arrow_Plastic_Glass_Emtpy, Arrow_Plastic_Glass_Poison, Arrow_Plastic_Glass_Poison_Long, Arrow_Plastic_Glass_Poison_Strong, Arrow_Plastic_Glass_Slowness, Arrow_Plastic_Glass_Slowness_Long, Arrow_Plastic_Glass_Weakness, Arrow_Plastic_Glass_Weakness_Long, Arrow_Plastic_Glass_Holy_Water,
	Shape_Mold_Empty, Shape_Mold_Credit, Shape_Mold_Bun, Shape_Mold_Bread, Shape_Mold_Baguette, Shape_Mold_Cylinder, Shape_Mold_Name,
	Shape_Slicer_Empty, Shape_Slicer_Flat, Shape_Slicer_Stripes,
	Shape_Extruder_Empty, Shape_Extruder_Bottle, Shape_Extruder_Plate, Shape_Extruder_Cell, Shape_Extruder_Ring, Shape_Extruder_Rod, Shape_Extruder_Bolt, Shape_Extruder_Ingot, Shape_Extruder_Wire, Shape_Extruder_Casing, Shape_Extruder_Pipe_Tiny, Shape_Extruder_Pipe_Small, Shape_Extruder_Pipe_Medium, Shape_Extruder_Pipe_Large, Shape_Extruder_Pipe_Huge, Shape_Extruder_Block, Shape_Extruder_Sword, Shape_Extruder_Pickaxe, Shape_Extruder_Shovel, Shape_Extruder_Axe, Shape_Extruder_Hoe, Shape_Extruder_Hammer, Shape_Extruder_File, Shape_Extruder_Saw, Shape_Extruder_Gear,
	Key_Iron, Key_Gold, Key_Copper, Key_Tin, Key_Bronze, Key_Brass, Key_Silver, Key_Platinum, Key_Lead, Key_Plastic,
	Module_Stone_Generator,
	Credit_Copper, Credit_Iron, Credit_Silver, Credit_Gold, Credit_Platinum, Credit_Osmium,
	Credit_Greg_Copper, Credit_Greg_Cupronickel, Credit_Greg_Silver, Credit_Greg_Gold, Credit_Greg_Platinum, Credit_Greg_Osmium, Credit_Greg_Naquadah, Credit_Greg_Neutronium,
	Coin_Gold_Ancient, Coin_Doge, Coin_Chocolate,
	Cell_Universal_Fluid,
	Cell_Empty, Cell_Water, Cell_Lava, Cell_Air,
	Large_Fluid_Cell_Steel, Large_Fluid_Cell_TungstenSteel,
	Measuring_Pot, Measuring_Pot_Raw,
	ThermosCan_Empty,
	ThermosCan_Dark_Coffee, ThermosCan_Dark_Cafe_au_lait, ThermosCan_Coffee, ThermosCan_Cafe_au_lait, ThermosCan_Lait_au_cafe, ThermosCan_Dark_Chocolate_Milk,
	ThermosCan_Chocolate_Milk,
	ThermosCan_Tea, ThermosCan_Sweet_Tea, ThermosCan_Ice_Tea,
	Bottle_Empty,
	Bottle_Honey, Bottle_Honeydew, Bottle_Royal_Jelly, Bottle_Ambrosia,
	Bottle_Milk, Bottle_Cream, Bottle_Soy_Milk,
	Bottle_Holy_Water,
	Bottle_Purple_Drink,
	Bottle_Olive_Oil, Bottle_Sunflower_Oil, Bottle_Nut_Oil,
	Bottle_Mayo,
	Bottle_Chocolate_Cream, Bottle_Nutella,
	Bottle_Grape_Juice, Bottle_Wine, Bottle_Vinegar, Bottle_Dressing,
	Bottle_Strawberry_Juice,
	Bottle_Banana_Juice,
	Bottle_Potato_Juice, Bottle_Vodka, Bottle_Leninade,
	Bottle_Mineral_Water, Bottle_Salty_Water,
	Bottle_Rice_Water, Bottle_Sake,
	Bottle_Reed_Water, Bottle_Rum, Bottle_Pirate_Brew,
	Bottle_Hops_Juice, Bottle_Dark_Beer, Bottle_Dragon_Blood,
	Bottle_Wheaty_Juice, Bottle_Scotch, Bottle_Glen_McKenner,
	Bottle_Wheaty_Hops_Juice, Bottle_Beer,
	Bottle_Chilly_Sauce, Bottle_Hot_Sauce, Bottle_Diabolo_Sauce, Bottle_Diablo_Sauce, Bottle_Snitches_Glitch_Sauce,
	Bottle_Apple_Juice, Bottle_Cider,
	Bottle_Golden_Apple_Juice, Bottle_Golden_Cider,
	Bottle_Iduns_Apple_Juice, Bottle_Notches_Brew,
	Bottle_Lemon_Juice, Bottle_Limoncello, Bottle_Lemonade, Bottle_Alcopops, Bottle_Cave_Johnsons_Grenade_Juice,
	Pill_Empty,
	Pill_Mint, Pill_Red, Pill_Blue,
	Pill_Iodine,
	Pill_Antidote,
	Pill_Cure_All,
	Food_Can_Empty,
	Food_Can_Undefined_1, Food_Can_Undefined_2, Food_Can_Undefined_3, Food_Can_Undefined_4, Food_Can_Undefined_5, Food_Can_Undefined_6,
	Food_Can_Meat_1, Food_Can_Meat_2, Food_Can_Meat_3, Food_Can_Meat_4, Food_Can_Meat_5, Food_Can_Meat_6,
	Food_Can_Fish_1, Food_Can_Fish_2, Food_Can_Fish_3, Food_Can_Fish_4, Food_Can_Fish_5, Food_Can_Fish_6,
	Food_Can_Veggie_1, Food_Can_Veggie_2, Food_Can_Veggie_3, Food_Can_Veggie_4, Food_Can_Veggie_5, Food_Can_Veggie_6,
	Food_Can_Fruit_1, Food_Can_Fruit_2, Food_Can_Fruit_3, Food_Can_Fruit_4, Food_Can_Fruit_5, Food_Can_Fruit_6,
	Food_Can_Bread_1, Food_Can_Bread_2, Food_Can_Bread_3, Food_Can_Bread_4, Food_Can_Bread_5, Food_Can_Bread_6,
	Food_Can_Rotten_1, Food_Can_Rotten_2, Food_Can_Rotten_3, Food_Can_Rotten_4, Food_Can_Rotten_5, Food_Can_Rotten_6,
	Food_Can_Chum_1, Food_Can_Chum_2, Food_Can_Chum_3, Food_Can_Chum_4, Food_Can_Chum_5, Food_Can_Chum_6,
	Food_PotatoChips_Raw, Food_PotatoChips, Food_PotatoChips_Packaged, Food_ChiliChips, Food_ChiliChips_Packaged,
	Food_Cheese, Food_Cheese_Bar, Food_Cheese_Sliced,
	Food_Rib_Raw, Food_Rib_Cooked,
	Food_RibEyeSteak_Raw, Food_RibEyeSteak_Cooked,
	Food_Bacon_Raw, Food_Bacon_Cooked,
	Food_Ham_Raw, Food_Ham_Cooked, Food_Ham_Slice_Raw, Food_Ham_Slice_Cooked,
	Food_Chum, Food_Chum_On_Stick,
	Food_Tofu, Food_SoylentGreen,
	Food_Meat, Food_Meat_Raw,
	Food_Chocolate,
	Food_Dough, Food_Dough_Flat,
	Food_Dough_Sugar,
	Food_Dough_Sugar_Raisins,
	Food_Dough_Sugar_Chocolate_Raisins,
	Food_Dough_Chocolate,
	Food_Dough_Egg, Food_Dough_Egg_Flat,
	Food_Cookie_Raw, Food_Cookie_Raisins, Food_Cookie_Raisins_Raw, Food_Cookie_Chocolate_Raisins, Food_Cookie_Chocolate_Raisins_Raw,
	Food_Burger_Tofu, Food_Burger_Soylent, Food_Burger_Veggie, Food_Burger_Cheese, Food_Burger_Meat, Food_Burger_Chum,
	Food_Sandwich_Veggie, Food_Sandwich_Cheese, Food_Sandwich_Bacon, Food_Sandwich_Steak,
	Food_Large_Sandwich_Veggie, Food_Large_Sandwich_Cheese, Food_Large_Sandwich_Bacon, Food_Large_Sandwich_Steak,
	Food_Fries, Food_Fries_Raw, Food_Fries_Packaged,
	Food_Potato, Food_Potato_Baked, Food_Potato_On_Stick, Food_Potato_On_Stick_Roasted, Food_Potato_Poisonous,
	Food_CakeBottom, Food_CakeBottom_Raw,
	Food_Bread, Food_Bread_Raw, Food_Bread_Sliced, Food_Breads_Sliced,
	Food_Bun, Food_Bun_Raw, Food_Bun_Sliced, Food_Buns_Sliced,
	Food_Baguette, Food_Baguette_Raw, Food_Baguette_Sliced, Food_Baguettes_Sliced,
	Food_Pizza_Veggie, Food_Pizza_Veggie_Raw, Food_Pizza_Cheese, Food_Pizza_Cheese_Raw, Food_Pizza_Meat, Food_Pizza_Meat_Raw,
	Food_Chili_Pepper,
	Food_Banana, Food_Banana_Sliced,
	Food_Lemon, Food_Lemon_Sliced,
	Food_Onion, Food_Onion_Sliced,
	Food_Carrot, Food_Carrot_Sliced,
	Food_Tomato, Food_Tomato_Sliced, Food_MTomato,
	Food_Grapes_Purple, Food_Grapes_Green, Food_Raisins_Purple, Food_Raisins_Green, Food_Raisins_Chocolate,
	Food_Cucumber, Food_Cucumber_Sliced,
	Schematic, Schematic_Crafting, Schematic_1by1, Schematic_2by2, Schematic_3by3,
	Circuit_Plate_Empty, Circuit_Plate_Copper, Circuit_Plate_Gold, Circuit_Plate_Platinum, Circuit_Plate_Magic, Circuit_Plate_Enderium, Circuit_Plate_Signalum, Circuit_Plate_HSLA,
	Circuit_Wire_Copper, Circuit_Wire_Gold, Circuit_Wire_Platinum, Circuit_Wire_Magic, Circuit_Wire_Enderium, Circuit_Wire_Signalum,
	Circuit_Board_Basic, Circuit_Board_Good, Circuit_Board_Advanced, Circuit_Board_Elite, Circuit_Board_Master, Circuit_Board_Ultimate, Circuit_Board_Magic, Circuit_Board_Enderium, Circuit_Board_Signalum, Circuit_Board_BC_Redstone, Circuit_Board_BC_Iron, Circuit_Board_BC_Gold, Circuit_Board_BC_Diamond, Circuit_Board_BC_Ender, Circuit_Board_BC_Quartz, Circuit_Board_BC_Comparator, Circuit_Board_BC_Emerald, Circuit_Board_HSLA_Circuit, Circuit_Board_Power_Module,
	Circuit_Part_Basic, Circuit_Part_Good, Circuit_Part_Advanced, Circuit_Part_Elite, Circuit_Part_Master, Circuit_Part_Ultimate, Circuit_Part_Magic, Circuit_Part_Enderium, Circuit_Part_Signalum, Circuit_Part_EnderPearl, Circuit_Part_EnderEye,
	Circuit_Primitive, Circuit_Basic, Circuit_Good, Circuit_Advanced, Circuit_Elite, Circuit_Master, Circuit_Ultimate, Circuit_Magic, Circuit_Enderium, Circuit_Signalum, Circuit_BC_Redstone, Circuit_BC_Iron, Circuit_BC_Gold, Circuit_BC_Diamond, Circuit_BC_Ender, Circuit_BC_Quartz, Circuit_BC_Comparator, Circuit_BC_Emerald,
	Circuit_Crystal_Diamond, Circuit_Crystal_Ruby, Circuit_Crystal_Emerald, Circuit_Crystal_Sapphire,
	Processor_Crystal_Empty, Processor_Crystal_Diamond, Processor_Crystal_Ruby, Processor_Crystal_Emerald, Processor_Crystal_Sapphire,
	Electric_Motor_LV, Electric_Motor_MV, Electric_Motor_HV, Electric_Motor_EV, Electric_Motor_IV, Electric_Motor_LuV, Electric_Motor_ZPM, Electric_Motor_UV,
	Electric_Pump_LV, Electric_Pump_MV, Electric_Pump_HV, Electric_Pump_EV, Electric_Pump_IV, Electric_Pump_LuV, Electric_Pump_ZPM, Electric_Pump_UV,
	Conveyor_Module_LV, Conveyor_Module_MV, Conveyor_Module_HV, Conveyor_Module_EV, Conveyor_Module_IV, Conveyor_Module_LuV, Conveyor_Module_ZPM, Conveyor_Module_UV,
	Electric_Piston_LV, Electric_Piston_MV, Electric_Piston_HV, Electric_Piston_EV, Electric_Piston_IV, Electric_Piston_LuV, Electric_Piston_ZPM, Electric_Piston_UV,
	Field_Generator_LV, Field_Generator_MV, Field_Generator_HV, Field_Generator_EV, Field_Generator_IV, Field_Generator_LuV, Field_Generator_ZPM, Field_Generator_UV,
	Robot_Arm_LV, Robot_Arm_MV, Robot_Arm_HV, Robot_Arm_EV, Robot_Arm_IV, Robot_Arm_LuV, Robot_Arm_ZPM, Robot_Arm_UV,
	Emitter_LV, Emitter_MV, Emitter_HV, Emitter_EV, Emitter_IV, Emitter_LuV, Emitter_ZPM, Emitter_UV,
	Sensor_LV, Sensor_MV, Sensor_HV, Sensor_EV, Sensor_IV, Sensor_LuV, Sensor_ZPM, Sensor_UV,
	Battery_Hull_LV, Battery_Hull_MV, Battery_Hull_HV, Battery_SU_LV_SulfuricAcid, Battery_SU_LV_Mercury, Battery_SU_MV_SulfuricAcid, Battery_SU_MV_Mercury, Battery_SU_HV_SulfuricAcid, Battery_SU_HV_Mercury, Battery_RE_ULV_Tantalum, Battery_RE_LV_Cadmium, Battery_RE_LV_Lithium, Battery_RE_LV_Sodium, Battery_RE_MV_Cadmium, Battery_RE_MV_Lithium, Battery_RE_MV_Sodium, Battery_RE_HV_Cadmium, Battery_RE_HV_Lithium, Battery_RE_HV_Sodium, ZPM,
	Fuel_Can_Plastic_Empty, Fuel_Can_Plastic_Filled,
	Upgrade_Battery, Upgrade_Overclocker, Upgrade_Muffler, Upgrade_Lock,
	Cover_Blank,
	Cover_Crafting,
	Cover_Auto_Switch,
	Cover_Machine_Display,
	Cover_Screen,
	Cover_Controller,
	Cover_ActivityDetector, Cover_FluidDetector, Cover_ItemDetector, Cover_EnergyDetector,
	Cover_Drain, Cover_Shutter,
	Cover_SolarPanel, Cover_SolarPanel_8V, Cover_SolarPanel_LV, Cover_SolarPanel_MV, Cover_SolarPanel_HV, Cover_SolarPanel_EV, Cover_SolarPanel_IV, Cover_SolarPanel_LuV, Cover_SolarPanel_ZPM, Cover_SolarPanel_UV,
	Ingot_IridiumAlloy,
	Plank_Oak, Plank_Spruce, Plank_Birch, Plank_Jungle, Plank_Acacia, Plank_DarkOak, Plank_Larch, Plank_Teak, Plank_Acacia_Green, Plank_Lime, Plank_Chestnut, Plank_Wenge, Plank_Baobab, Plank_Sequoia, Plank_Kapok, Plank_Ebony, Plank_Mahagony, Plank_Balsa, Plank_Willow, Plank_Walnut, Plank_Greenheart, Plank_Cherry, Plank_Mahoe, Plank_Poplar, Plank_Palm, Plank_Papaya, Plank_Pine, Plank_Plum, Plank_Maple, Plank_Citrus,
	Dye_SquidInk, Dye_Bonemeal, Dye_Cactus, Dye_Cocoa,
	Duct_Tape,
	Paper_Printed_Pages,
	Paper_Magic_Empty, Paper_Magic_Page, Paper_Magic_Pages,
	Paper_Punch_Card_Empty, Paper_Punch_Card_Encoded,
	Woodbucket_Cu_Empty, Woodbucket_Cu_Water, Woodbucket_Cu_Milk,
	Woodbucket_Sn_Empty, Woodbucket_Sn_Water, Woodbucket_Sn_Milk,
	Woodbucket_Pb_Empty, Woodbucket_Pb_Water, Woodbucket_Pb_Milk,
	Woodbucket_Bi_Empty, Woodbucket_Bi_Water, Woodbucket_Bi_Milk,
	Woodbucket_Zn_Empty, Woodbucket_Zn_Water, Woodbucket_Zn_Milk,
	Tool_Matches, Tool_MatchBox_Empty, Tool_MatchBox_Used, Tool_MatchBox_Full,
	Tool_Lighter_Invar_Empty, Tool_Lighter_Invar_Used, Tool_Lighter_Invar_Full,
	Tool_Lighter_Platinum_Empty, Tool_Lighter_Platinum_Used, Tool_Lighter_Platinum_Full,
	Tool_Cheat, Tool_Scanner,
	Tool_DataOrb, Tool_DataStick, Tool_Sonictron,
	Tool_Sword_Bronze, Tool_Pickaxe_Bronze, Tool_Shovel_Bronze, Tool_Axe_Bronze, Tool_Hoe_Bronze, // IC2
	Tool_Sword_Steel, Tool_Pickaxe_Steel, Tool_Shovel_Steel, Tool_Axe_Steel, Tool_Hoe_Steel, // RC
	
	Spray_Empty, Spray_Bug, Spray_Pepper, Spray_Hydration, Spray_Ice, Spray_Extinguisher, Spray_Extinguisher_Used, Spray_Hardener, Spray_Hardener_Used, Spray_Foam_Remover, Spray_Foam_Remover_Used,
	Color_00, Color_01, Color_02, Color_03, Color_04, Color_05, Color_06, Color_07, Color_08, Color_09, Color_10, Color_11, Color_12, Color_13, Color_14, Color_15,
	Spray_Color_00, Spray_Color_01, Spray_Color_02, Spray_Color_03, Spray_Color_04, Spray_Color_05, Spray_Color_06, Spray_Color_07, Spray_Color_08, Spray_Color_09, Spray_Color_10, Spray_Color_11, Spray_Color_12, Spray_Color_13, Spray_Color_14, Spray_Color_15,
	Spray_Color_Used_00, Spray_Color_Used_01, Spray_Color_Used_02, Spray_Color_Used_03, Spray_Color_Used_04, Spray_Color_Used_05, Spray_Color_Used_06, Spray_Color_Used_07, Spray_Color_Used_08, Spray_Color_Used_09, Spray_Color_Used_10, Spray_Color_Used_11, Spray_Color_Used_12, Spray_Color_Used_13, Spray_Color_Used_14, Spray_Color_Used_15,
	Spray_Foam_00, Spray_Foam_01, Spray_Foam_02, Spray_Foam_03, Spray_Foam_04, Spray_Foam_05, Spray_Foam_06, Spray_Foam_07, Spray_Foam_08, Spray_Foam_09, Spray_Foam_10, Spray_Foam_11, Spray_Foam_12, Spray_Foam_13, Spray_Foam_14, Spray_Foam_15,
	Spray_Foam_Used_00, Spray_Foam_Used_01, Spray_Foam_Used_02, Spray_Foam_Used_03, Spray_Foam_Used_04, Spray_Foam_Used_05, Spray_Foam_Used_06, Spray_Foam_Used_07, Spray_Foam_Used_08, Spray_Foam_Used_09, Spray_Foam_Used_10, Spray_Foam_Used_11, Spray_Foam_Used_12, Spray_Foam_Used_13, Spray_Foam_Used_14, Spray_Foam_Used_15,
	
	Armor_Cheat, Armor_Cloaking, Armor_Lamp, Armor_LapotronicPack, Armor_ForceField,
	Energy_LapotronicOrb,
	Reactor_NeutronReflector,
	Component_Turbine_Bronze, Component_Turbine_Steel, Component_Turbine_Magnalium, Component_Turbine_TungstenSteel, Component_Turbine_Carbon,
	Component_LavaFilter,
	Component_Filter,
	
	Transformer_LV_ULV, Transformer_MV_LV, Transformer_HV_MV, Transformer_EV_HV, Transformer_IV_EV, Transformer_LuV_IV, Transformer_ZPM_LuV, Transformer_UV_ZPM, Transformer_MAX_UV,
	
	NULL;
	
	public static final IL[]
	  DYE_ONLY_ITEMS = {Color_00, Color_01, Color_02, Color_03, Color_04, Color_05, Color_06, Color_07, Color_08, Color_09, Color_10, Color_11, Color_12, Color_13, Color_14, Color_15}
	, SPRAY_CAN_DYES = {Spray_Color_00, Spray_Color_01, Spray_Color_02, Spray_Color_03, Spray_Color_04, Spray_Color_05, Spray_Color_06, Spray_Color_07, Spray_Color_08, Spray_Color_09, Spray_Color_10, Spray_Color_11, Spray_Color_12, Spray_Color_13, Spray_Color_14, Spray_Color_15}
	, SPRAY_CAN_DYES_USED = {Spray_Color_Used_00, Spray_Color_Used_01, Spray_Color_Used_02, Spray_Color_Used_03, Spray_Color_Used_04, Spray_Color_Used_05, Spray_Color_Used_06, Spray_Color_Used_07, Spray_Color_Used_08, Spray_Color_Used_09, Spray_Color_Used_10, Spray_Color_Used_11, Spray_Color_Used_12, Spray_Color_Used_13, Spray_Color_Used_14, Spray_Color_Used_15}
	, SPRAY_CAN_FOAM = {Spray_Foam_00, Spray_Foam_01, Spray_Foam_02, Spray_Foam_03, Spray_Foam_04, Spray_Foam_05, Spray_Foam_06, Spray_Foam_07, Spray_Foam_08, Spray_Foam_09, Spray_Foam_10, Spray_Foam_11, Spray_Foam_12, Spray_Foam_13, Spray_Foam_14, Spray_Foam_15}
	, SPRAY_CAN_FOAM_USED = {Spray_Foam_Used_00, Spray_Foam_Used_01, Spray_Foam_Used_02, Spray_Foam_Used_03, Spray_Foam_Used_04, Spray_Foam_Used_05, Spray_Foam_Used_06, Spray_Foam_Used_07, Spray_Foam_Used_08, Spray_Foam_Used_09, Spray_Foam_Used_10, Spray_Foam_Used_11, Spray_Foam_Used_12, Spray_Foam_Used_13, Spray_Foam_Used_14, Spray_Foam_Used_15}
	, CANS_UNDEFINED = {Food_Can_Undefined_1, Food_Can_Undefined_2, Food_Can_Undefined_3, Food_Can_Undefined_4, Food_Can_Undefined_5, Food_Can_Undefined_6}
	, CANS_ROTTEN = {Food_Can_Rotten_1, Food_Can_Rotten_2, Food_Can_Rotten_3, Food_Can_Rotten_4, Food_Can_Rotten_5, Food_Can_Rotten_6}
	, CANS_CHUM = {Food_Can_Chum_1, Food_Can_Chum_2, Food_Can_Chum_3, Food_Can_Chum_4, Food_Can_Chum_5, Food_Can_Chum_6}
	, CANS_FRUIT = {Food_Can_Fruit_1, Food_Can_Fruit_2, Food_Can_Fruit_3, Food_Can_Fruit_4, Food_Can_Fruit_5, Food_Can_Fruit_6}
	, CANS_VEGGIE = {Food_Can_Veggie_1, Food_Can_Veggie_2, Food_Can_Veggie_3, Food_Can_Veggie_4, Food_Can_Veggie_5, Food_Can_Veggie_6}
	, CANS_BREAD = {Food_Can_Bread_1, Food_Can_Bread_2, Food_Can_Bread_3, Food_Can_Bread_4, Food_Can_Bread_5, Food_Can_Bread_6}
	, CANS_MEAT = {Food_Can_Meat_1, Food_Can_Meat_2, Food_Can_Meat_3, Food_Can_Meat_4, Food_Can_Meat_5, Food_Can_Meat_6}
	, CANS_FISH = {Food_Can_Fish_1, Food_Can_Fish_2, Food_Can_Fish_3, Food_Can_Fish_4, Food_Can_Fish_5, Food_Can_Fish_6}
	, TRANSFORMERS = {Transformer_LV_ULV, Transformer_MV_LV, Transformer_HV_MV, Transformer_EV_HV, Transformer_IV_EV, Transformer_LuV_IV, Transformer_ZPM_LuV, Transformer_UV_ZPM, Transformer_MAX_UV}
	;
	private ItemStack mStack;
	private boolean mHasNotBeenSet = T;
	
	public static Fluid sOilExtraHeavy, sOilHeavy, sOilMedium, sOilLight, sNaturalGas;
	
	@Override
	public IItemContainer set(Item aItem) {
		mHasNotBeenSet = F;
		if (aItem == null) {
//			new Exception().printStackTrace(GT_Log.deb);
			return this;
		}
		ItemStack aStack = UT.Stacks.make(aItem, 1, 0);
		mStack = UT.Stacks.amount(1, aStack);
		return this;
	}
	
	@Override
	public IItemContainer set(ItemStack aStack) {
		mHasNotBeenSet = F;
		if (UT.Stacks.invalid(aStack)) {
//			new Exception().printStackTrace(GT_Log.deb);
			return this;
		}
		mStack = UT.Stacks.amount(1, aStack);
		return this;
	}
	
	public IItemContainer set(Item aItem, OreDictItemData aData, String... aOreDict) {
		mHasNotBeenSet = F;
		if (aItem == null) {
//			new Exception().printStackTrace(GT_Log.deb);
			return this;
		}
		ItemStack aStack = UT.Stacks.make(aItem, 1, 0);
		mStack = UT.Stacks.amount(1, aStack);
		if (aData != null && !OM.reg(aData.toString(), UT.Stacks.make(aItem, 1, W))) OM.data(UT.Stacks.make(aItem, 1, W), aData);
		for (String tOreDict : aOreDict) OM.reg(tOreDict, UT.Stacks.make(aItem, 1, W));
		return this;
	}
	
	public IItemContainer set(ItemStack aStack, OreDictItemData aData, String... aOreDict) {
		mHasNotBeenSet = F;
		if (UT.Stacks.invalid(aStack)) {
//			new Exception().printStackTrace(GT_Log.deb);
			return this;
		}
		mStack = UT.Stacks.amount(1, aStack);
		if (aData != null && !OM.reg(aData.toString(), UT.Stacks.amount(1, aStack))) OM.data(UT.Stacks.amount(1, aStack), aData);
		for (String tOreDict : aOreDict) OM.reg(tOreDict, UT.Stacks.amount(1, aStack));
		return this;
	}
	
	@Override
	public Item getItem() {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return null;
		return mStack.getItem();
	}
	
	@Override
	public Block getBlock() {
		return UT.Stacks.block(get(0));
	}
	
	@Override
	public final boolean hasBeenSet() {
		return !mHasNotBeenSet;
	}
	
	@Override
	public boolean equal(Object aStack) {
		if (aStack instanceof Block) return aStack != NB && getBlock() == aStack;
		return equal(aStack, F, F);
	}
	
	@Override
	public boolean equal(Object aStack, boolean aWildcard, boolean aIgnoreNBT) {
		if (UT.Stacks.invalid(aStack)) return F;
		return UT.Stacks.equal((ItemStack)aStack, aWildcard?getWildcard(1):get(1), aIgnoreNBT);
	}
	
	@Override
	public ItemStack get(long aAmount, Object... aReplacements) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return UT.Stacks.amount(aAmount, aReplacements);
		return UT.Stacks.amount(aAmount, OM.get_(mStack));
	}
	
	@Override
	public ItemStack getWildcard(long aAmount, Object... aReplacements) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return UT.Stacks.amount(aAmount, aReplacements);
		return UT.Stacks.copyAmountAndMeta(aAmount, W, OM.get_(mStack));
	}
	
	@Override
	public ItemStack getUndamaged(long aAmount, Object... aReplacements) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return UT.Stacks.amount(aAmount, aReplacements);
		return UT.Stacks.copyAmountAndMeta(aAmount, 0, OM.get_(mStack));
	}
	
	@Override
	public ItemStack getAlmostBroken(long aAmount, Object... aReplacements) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return UT.Stacks.amount(aAmount, aReplacements);
		return UT.Stacks.copyAmountAndMeta(aAmount, mStack.getMaxDamage()-1, OM.get_(mStack));
	}
	
	@Override
	public ItemStack getWithName(long aAmount, String aDisplayName, Object... aReplacements) {
		ItemStack rStack = get(1, aReplacements);
		if (UT.Stacks.invalid(rStack)) return null;
		rStack.setStackDisplayName(aDisplayName);
		return UT.Stacks.amount(aAmount, rStack);
	}
	
	@Override
	public ItemStack getWithCharge(long aAmount, long aEnergy, Object... aReplacements) {
		ItemStack rStack = get(1, aReplacements);
		if (UT.Stacks.invalid(rStack)) return null;
		GT_ModHandler.chargeElectricItem(rStack, UT.Code.bindInt(aEnergy), Integer.MAX_VALUE, true, false);
		return UT.Stacks.amount(aAmount, rStack);
	}
	
	@Override
	public ItemStack getWithDamage(long aAmount, long aMetaValue, Object... aReplacements) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return UT.Stacks.amount(aAmount, aReplacements);
		return UT.Stacks.copyAmountAndMeta(aAmount, aMetaValue, OM.get_(mStack));
	}
	
	@Override
	public ItemStack getWithNBT(long aAmount, NBTTagCompound aNBT, Object... aReplacements) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		if (UT.Stacks.invalid(mStack)) return UT.Stacks.amount(aAmount, aReplacements);
		ItemStack rStack = UT.Stacks.amount(aAmount, OM.get_(mStack));
		rStack.setTagCompound(aNBT);
		return rStack;
	}
	
	@Override
	public IItemContainer registerOre(Object... aOreNames) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		for (Object tOreName : aOreNames) OM.reg(tOreName, get(1));
		return this;
	}
	
	@Override
	public IItemContainer registerWildcardAsOre(Object... aOreNames) {
		if (mHasNotBeenSet && D3) throw new IllegalAccessError("The Enum '" + name() + "' has not been set to an Item at this time!");
		for (Object tOreName : aOreNames) OM.reg(tOreName, getWildcard(1));
		return this;
	}
}