package gregapi.enchants;

import gregapi.config.Config;
import gregapi.config.ConfigCategories;
import gregapi.data.MT;
import gregapi.lang.LanguageHandler;
import gregapi.util.UT;
import net.minecraft.enchantment.EnchantmentDamage;
import net.minecraft.entity.Entity;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.item.ItemStack;

/**
 * @author Gregorius Techneticies
 */
public class Enchantment_Radioactivity extends EnchantmentDamage {
	public static Enchantment_Radioactivity INSTANCE;
	
	public Enchantment_Radioactivity() {
		super(Config.addIDConfig(ConfigCategories.IDs.enchantments, "Radioactivity", 14), 0, -1);
		LanguageHandler.add(getName(), "Radioactivity");
		MT.Cyanite			.setEnchantmentForTools(this, 1).setEnchantmentForArmors(this, 1);
		MT.Yellorium		.setEnchantmentForTools(this, 1).setEnchantmentForArmors(this, 1);
		MT.Blutonium		.setEnchantmentForTools(this, 2).setEnchantmentForArmors(this, 2);
		MT.Pu				.setEnchantmentForTools(this, 1).setEnchantmentForArmors(this, 1);
		MT.U_235			.setEnchantmentForTools(this, 2).setEnchantmentForArmors(this, 2);
		MT.Co_60			.setEnchantmentForTools(this, 2).setEnchantmentForArmors(this, 2);
		MT.Pu_241			.setEnchantmentForTools(this, 3).setEnchantmentForArmors(this, 3);
		MT.Pu_243			.setEnchantmentForTools(this, 3).setEnchantmentForArmors(this, 3);
		MT.Am_241			.setEnchantmentForTools(this, 4).setEnchantmentForArmors(this, 4);
		MT.Nq_528			.setEnchantmentForTools(this, 4).setEnchantmentForArmors(this, 4);
		MT.Nq_522			.setEnchantmentForTools(this, 5).setEnchantmentForArmors(this, 5);
		INSTANCE = this;
	}
	
    @Override
	public int getMinEnchantability(int aLevel) {
        return Integer.MAX_VALUE;
    }
    
    @Override
	public int getMaxEnchantability(int aLevel) {
        return 0;
    }
    
    @Override
	public int getMaxLevel() {
        return 5;
    }
    
    @Override
	public boolean canApply(ItemStack par1ItemStack) {
        return false;
    }
    
    @Override
    public boolean isAllowedOnBooks() {
        return false;
    }
    
    @Override
	public void func_151367_b(EntityLivingBase aHurtEntity, Entity aDamagingEntity, int aLevel) {
        UT.Entities.applyRadioactivity(aHurtEntity, aLevel, 1);
    }
    
    @Override
	public String getName() {
        return "enchantment.damage.radioactivity";
    }
}