package gregapi.tileentity.connectors;

import static gregapi.data.CS.*;
import gregapi.block.multitileentity.MultiTileEntityBlock;
import gregapi.block.multitileentity.MultiTileEntityRegistry;
import gregapi.code.ArrayListNoNulls;
import gregapi.code.TagData;
import gregapi.data.CS.IconsGT;
import gregapi.data.*;
import gregapi.data.LH.Chat;
import gregapi.old.Textures;
import gregapi.oredict.OreDictMaterial;
import gregapi.render.BlockTextureDefault;
import gregapi.render.BlockTextureMulti;
import gregapi.render.ITexture;
import gregapi.tileentity.ITileEntityAdjacentInventoryUpdatable;
import gregapi.tileentity.data.ITileEntityProgress;
import gregapi.tileentity.delegate.DelegatorTileEntity;
import gregapi.util.OM;
import gregapi.util.UT;

import java.util.ArrayList;
import java.util.Collection;
import java.util.HashMap;
import java.util.List;

import net.minecraft.inventory.IInventory;
import net.minecraft.inventory.ISidedInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.tileentity.TileEntityDispenser;
import net.minecraft.tileentity.TileEntityHopper;

/**
 * @author Gregorius Techneticies
 */
public class MultiTileEntityPipeItem extends TileEntityBase10ConnectorRendered implements ISidedInventory, ITileEntityProgress, ITileEntityItemPipe {
	public long mTransferredItems = 0, mStepSize = 1;
	public byte mLastReceivedFrom = SIDE_UNDEFINED, oLastReceivedFrom = SIDE_UNDEFINED, mRenderType = 0;
	
	/**
	 * Utility to quickly add a whole set of Item Pipes.
	 * May use up to 100 IDs, even if it is just 6 right now!
	 */
	public static void addItemPipes(int aID, int aCreativeTabID, long aStepSize, int aInvSize, boolean aRecipe, MultiTileEntityRegistry aRegistry, MultiTileEntityBlock aBlock, Class aClass, OreDictMaterial aMat) {
		OM.reg_(OP.pipeMedium				, aMat, aRegistry.add(aMat.getLocal() + " Item Pipe"						, "Item Pipes"				, aID+ 2, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[ 8], NBT_PIPESIZE, aStepSize      , NBT_INV_SIZE, aInvSize    ), aRecipe?new Object[]{"PPP", "wzh"       , 'P', OP.plateCurved.dat(aMat)}:ZL_OBJECT));
        OM.reg_(OP.pipeLarge				, aMat, aRegistry.add("Large " + aMat.getLocal() + " Item Pipe"				, "Item Pipes"				, aID+ 3, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[12], NBT_PIPESIZE, aStepSize /   2, NBT_INV_SIZE, aInvSize * 2), aRecipe?new Object[]{"PPP", "wzh", "PPP", 'P', OP.plateCurved.dat(aMat)}:ZL_OBJECT));
        OM.reg_(OP.pipeHuge					, aMat, aRegistry.add("Huge " + aMat.getLocal() + " Item Pipe"				, "Item Pipes"				, aID+ 4, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   0, NBT_DIAMETER, PIXELS_POS[16], NBT_PIPESIZE, aStepSize /   4, NBT_INV_SIZE, aInvSize * 4), aRecipe?new Object[]{"PPP", "wzh", "PPP", 'P', OP.plateDouble.dat(aMat)}:ZL_OBJECT));
        OM.reg_(OP.pipeRestrictiveMedium	, aMat, aRegistry.add("Restrictive " + aMat.getLocal() + " Item Pipe"		, "Item Pipes"				, aID+ 5, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   1, NBT_DIAMETER, PIXELS_POS[ 8], NBT_PIPESIZE, aStepSize * 100, NBT_INV_SIZE, aInvSize    ), aRecipe?new Object[]{" h ", "RPR", " R ", 'P', OP.pipeMedium.dat(aMat), 'R', OP.ring.dat(MT.Steel)}:ZL_OBJECT));
        OM.reg_(OP.pipeRestrictiveLarge		, aMat, aRegistry.add("Restrictive Large " + aMat.getLocal() + " Item Pipe"	, "Item Pipes"				, aID+ 6, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   1, NBT_DIAMETER, PIXELS_POS[12], NBT_PIPESIZE, aStepSize *  50, NBT_INV_SIZE, aInvSize * 2), aRecipe?new Object[]{"hR ", "RPR", " R ", 'P', OP.pipeLarge.dat(aMat), 'R', OP.ring.dat(MT.Steel)}:ZL_OBJECT));
        OM.reg_(OP.pipeRestrictiveHuge		, aMat, aRegistry.add("Restrictive Huge " + aMat.getLocal() + " Item Pipe"	, "Item Pipes"				, aID+ 7, aCreativeTabID, aClass, aMat.mToolQuality, 16, aBlock		, UT.NBT.getNBTs(null, NBT_MATERIAL, aMat, NBT_HARDNESS,   7.0F, NBT_RESISTANCE,   7.0F, NBT_COLOR, UT.Code.getRGBInt(aMat.mRGBaSolid), NBT_PIPERENDER,   1, NBT_DIAMETER, PIXELS_POS[16], NBT_PIPESIZE, aStepSize *  25, NBT_INV_SIZE, aInvSize * 4), aRecipe?new Object[]{" h ", "RPR", "RRR", 'P', OP.pipeHuge.dat(aMat), 'R', OP.ring.dat(MT.Steel)}:ZL_OBJECT));
    }
	
	@Override
	public void readFromNBT2(NBTTagCompound aNBT) {
    	super.readFromNBT2(aNBT);
    	if (aNBT.hasKey("gt.olast")) oLastReceivedFrom = aNBT.getByte("gt.olast");
    	if (aNBT.hasKey("gt.mlast")) mLastReceivedFrom = aNBT.getByte("gt.mlast");
    	if (aNBT.hasKey("gt.mtransfer")) mTransferredItems = aNBT.getLong("gt.mtransfer");
    	if (aNBT.hasKey(NBT_PIPESIZE)) mStepSize = aNBT.getLong(NBT_PIPESIZE);
    	if (aNBT.hasKey(NBT_PIPERENDER)) mRenderType = aNBT.getByte(NBT_PIPERENDER);
	}
	
	@Override
	public void writeToNBT2(NBTTagCompound aNBT) {
    	super.writeToNBT2(aNBT);
		aNBT.setByte("gt.olast", oLastReceivedFrom);
		aNBT.setByte("gt.mlast", mLastReceivedFrom);
		UT.NBT.setNumber(aNBT, "gt.mtransfer", mTransferredItems);
	}
	
	@Override
	public void addToolTips(List aList, ItemStack aStack, boolean aF3_H) {
		aList.add(Chat.CYAN + LH.get(LH.PIPE_STATS_STEPSIZE) + mStepSize);
		aList.add(Chat.CYAN + LH.get(LH.PIPE_STATS_BANDWIDTH) + getPipeCapacity());
		super.addToolTips(aList, aStack, aF3_H);
	}
	
    @Override
    public void onTick2(long aTimer, boolean aIsServerSide) {
    	super.onTick2(aTimer, aIsServerSide);
    	
	    if (aIsServerSide && aTimer % 10 == 0) {
			if (aTimer % 20 == 0) mTransferredItems = 0;
			
	    	if (oLastReceivedFrom == mLastReceivedFrom) {
	    		boolean tUpdate = F;
        		ArrayList<ITileEntityItemPipe> tPipeList = new ArrayListNoNulls<ITileEntityItemPipe>();
	        	for (boolean temp = T; temp && UT.Code.containsSomething(getInventory()) && pipeCapacityCheck();) {
	        		temp = F;
	        		tPipeList.clear();
	        		for (ITileEntityItemPipe tTileEntity : UT.Code.sortByValuesAcending(ITileEntityItemPipe.Util.scanPipes(this, new HashMap<ITileEntityItemPipe, Long>(), 0, F, F)).keySet()) {
	        			if (temp) break;
	        			tPipeList.add(tTileEntity);
	        			while (!temp && UT.Code.containsSomething(getInventory()) && tTileEntity.sendItemStack(this)) {
	        				tUpdate = T;
	        				for (ITileEntityItemPipe tPipe : tPipeList) if (!tPipe.incrementTransferCounter(1)) temp = T;
	        			}
	        		}
	        	}
	        	if (tUpdate) {
    				DelegatorTileEntity<TileEntity> tDelegator = getAdjacentTileEntity(mLastReceivedFrom);
    				if (tDelegator.mTileEntity instanceof ITileEntityAdjacentInventoryUpdatable) {
    					((ITileEntityAdjacentInventoryUpdatable)tDelegator.mTileEntity).adjacentInventoryUpdated(tDelegator.mSideOfTileEntity, this);
    				}
	        	}
	    	}
	    	
			if (!UT.Code.containsSomething(getInventory())) mLastReceivedFrom = SIDE_UNDEFINED;
	    	oLastReceivedFrom = mLastReceivedFrom;
		}
    }
    
	@Override
	public boolean insertItemStackIntoTileEntity(Object aSender, byte aSide) {
    	if (canEmitItemsTo(aSide, aSender)) {
	    	DelegatorTileEntity<TileEntity> tDelegator = getAdjacentTileEntity(aSide);
			if (tDelegator.mTileEntity != null && !(tDelegator.mTileEntity instanceof TileEntityBase09Connector)) {
				if ((!(tDelegator.mTileEntity instanceof TileEntityHopper) && !(tDelegator.mTileEntity instanceof TileEntityDispenser)) || getMetaDataAtSide(aSide) != tDelegator.mSideOfTileEntity) {
					return UT.Inventories.moveOneItemStack(aSender, tDelegator, SIDE_ANY, tDelegator.mSideOfTileEntity, null, F, (byte)64, (byte)1, (byte)64, (byte)1) > 0;
				}
			}
    	}
    	return F;
    }
	
	@Override public boolean incrementTransferCounter(long aIncrement) {mTransferredItems += aIncrement; return pipeCapacityCheck();}
	@Override public boolean sendItemStack(Object aSender) {if (pipeCapacityCheck()) for (byte i = 0, j = (byte)getRandomNumber(6); i < 6; i++) if (insertItemStackIntoTileEntity(aSender, (byte)((i+j)%6))) return T; return F;}
    
	@Override public boolean pipeCapacityCheck() {return mTransferredItems <= 0 || getPipeContent() < getMaxPipeCapacity();}
    @Override public long getStepSize() {return mStepSize;}
    
	protected long getPipeContent() {return mTransferredItems;}
	protected long getMaxPipeCapacity() {return Math.max(1, getPipeCapacity());}
	protected long getPipeCapacity() {return getSizeInventory();}
	
	protected int[] ACCESSIBLE_SLOTS;
	@Override public int[] getAccessibleSlotsFromSide(int aSide) {return ACCESSIBLE_SLOTS;}
	@Override public boolean canDrop(int aInventorySlot) {return T;}
	@Override public boolean canInsertItem(int aSlot, ItemStack aStack, int aSide) {if (!UT.Code.containsSomething(getInventory())) mLastReceivedFrom = (byte)aSide; return mLastReceivedFrom == aSide && slot(aSlot) == null;}
	@Override public boolean canExtractItem(int aSlot, ItemStack aStack, int aSide) {return T;}
	@Override public ItemStack[] getDefaultInventory(NBTTagCompound aNBT) {ItemStack[] rStack = super.getDefaultInventory(aNBT); ACCESSIBLE_SLOTS = new int[rStack.length]; for (int i = 0; i < ACCESSIBLE_SLOTS.length; i++) ACCESSIBLE_SLOTS[i] = i; return rStack;}
	
	@Override public boolean canEmitItemsTo					(byte aSide, Object aSender) {return (aSender != this || aSide != mLastReceivedFrom) && connected(aSide);}
	@Override public boolean canAcceptItemsFrom				(byte aSide, Object aSender) {return connected(aSide);}
	
	@Override public boolean canConnect						(byte aSide, DelegatorTileEntity<TileEntity> aDelegator) {return (aDelegator.mTileEntity instanceof ISidedInventory ? ((ISidedInventory)aDelegator.mTileEntity).getAccessibleSlotsFromSide(aDelegator.mSideOfTileEntity).length > 0 : (aDelegator.mTileEntity instanceof IInventory && ((IInventory)aDelegator.mTileEntity).getSizeInventory() > 0)) || UT.Inventories.isConnectableNonInventoryPipe(aDelegator.mTileEntity, aDelegator.mSideOfTileEntity);}
	
	@Override public long getProgressValue					(byte aSide) {return getPipeContent()*64;}
	@Override public long getProgressMax					(byte aSide) {return getMaxPipeCapacity()*64;}
	
	@Override public ITexture getTextureSide				(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {BlockTextureDefault tBase = new BlockTextureDefault(mMaterial, getIconIndexSide		(aSide, aConnections, aDiameter, aRenderPass), mIsGlowing, mRGBa); switch(mRenderType) {case 1: return new BlockTextureMulti(tBase, new BlockTextureDefault(Textures.BlockIcons.PIPE_RESTRICTOR)); default: return tBase;}}
	@Override public ITexture getTextureConnected			(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {BlockTextureDefault tBase = new BlockTextureDefault(mMaterial, getIconIndexConnected	(aSide, aConnections, aDiameter, aRenderPass), mIsGlowing, mRGBa); switch(mRenderType) {case 1: return new BlockTextureMulti(tBase, new BlockTextureDefault(Textures.BlockIcons.PIPE_RESTRICTOR)); default: return tBase;}}
	
	@Override public int getIconIndexSide					(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {return IconsGT.INDEX_BLOCK_PIPE_SIDE;}
	@Override public int getIconIndexConnected				(byte aSide, byte aConnections, float aDiameter, int aRenderPass) {return aDiameter<0.37F?OP.pipeTiny.mIconIndexBlock:aDiameter<0.49F?OP.pipeSmall.mIconIndexBlock:aDiameter<0.74F?OP.pipeMedium.mIconIndexBlock:aDiameter<0.99F?OP.pipeLarge.mIconIndexBlock:OP.pipeHuge.mIconIndexBlock;}
	
	@Override public Collection<TagData> getConnectorTypes	(byte aSide) {return TD.Connectors.ALL_PNEUMATIC_ITEM;}
	
	@Override public String getFacingTool() {return TOOL_wrench;}
	
	@Override public String getTileEntityName() {return "gt.multitileentity.connector.pipe.item";}
}